<?php

class actionIbackuperBackup extends cmsAction {

	public function run() {
		
		$form = $this->getForm('backup');
		
        // Парсим форму и получаем поля записи
        $ctype_id = $this->request->get('ctype_id');
		
        // Форма отправлена?
        $is_submitted = $this->request->has('submit');

        if ($is_submitted){

			$get_ctype = cmsCore::getModel('ibackuper')->getCtype($ctype_id);
			
			if (!$get_ctype){
				
				cmsUser::addSessionMessage(LANG_IBACKUPER_CTYPE_EMPTY, 'error');
				header('Refresh: 0');
				$this->halt();
			}
			
			$file = cmsConfig::get('upload_path') . '/ibackuper/backuper_' . $get_ctype['ctype']['name'] . '.txt';
			
			// Пишем содержимое в файл
			file_put_contents($file, cmsModel::arrayToYaml($get_ctype), LOCK_EX);
			
			// Выгружаем файл
			header("Content-Type: application/force-download");
			header("Content-Length: " . filesize($file));
			header('Content-Disposition: attachment; filename='.basename($file));
			header('Refresh: 0');
			
			if(ob_get_length()) { ob_end_clean(); }

			readfile($file);
			$this->halt();
		}
		
		return cmsTemplate::getInstance()->render('backend/backup', array(
			'form' => $form
		));
	}
}